///////////////////////////////////////////////////////////////////////////////////////////////
// Filename:    DynSystem.cpp
// Package:     SDESolver
// Class:       CDynSystem
// Purpose:     Represents an Ito vector stochastic differential equation:
//                  dX = a(X,t)*dt + b(X,t)*dW
//              where a is the drift vector and b is the diffusion matrix
// Written:     Dave Burke      03/08/02
///////////////////////////////////////////////////////////////////////////////////////////////

#include "DynSystem.h"

///////////////////////////////////////////////////////////////////////////////////////////////
// Functionn:   CDynSystem
// Class:       CDynSystem
// Purpose:     Default constructor
// Inputs:      None
// Outputs:     None
///////////////////////////////////////////////////////////////////////////////////////////////
CDynSystem::CDynSystem(void)
: m_nDimension(0)
{
    // Empty
}

///////////////////////////////////////////////////////////////////////////////////////////////
// Function:    ~CDynSystem
// Class:       CDynSystem
// Purpose:     Destructor
// Inputs:      None
// Outputs:     None
///////////////////////////////////////////////////////////////////////////////////////////////
CDynSystem::~CDynSystem(void)
{
    // Empty
}




