///////////////////////////////////////////////////////////////////////////////////////////////
// Filename     DynSystemModule.h
// Package:     SDESolver
// Purpose:     Load a shared object module and get pointer to the CDynSystem instance
// Written:     Dave Burke      03/08/02
///////////////////////////////////////////////////////////////////////////////////////////////

#ifndef DYNSYSTEMMODULE_H
#define DYNSYSTEMMODULE_H

#include <string>
#include "DynSystem.h"

class CDynSystemModule
{
    public:

    CDynSystemModule(std::string strDynSystem);
    virtual ~CDynSystemModule(void);

    CDynSystem* GetDynSystem(void);

    private:

    bool Load(void);
    bool Unload(void);

    std::string m_strDynSystem; // name of dynamical system
    CDynSystem* m_pDynSystem;   // pointer to instance of dynamical system
    void* m_pModule;            // pointer to module
};

#endif // DYNSYSTEMMODULE_H

