///////////////////////////////////////////////////////////////////////////////////////////////
// Filename:    EMSolver.h
// Package:     SDESolver
// Class:       CEMSolver
// Purpose:	    Euler-Maruyama SDE solver. Strong order 0.5
//              Ref: Kloeden, P. E. et al (1999): "Numerical Solution of Stochastic
//              Differential Equations", Springer-Verlag.
// Written:     Dave Burke      03/08/02
///////////////////////////////////////////////////////////////////////////////////////////////

#ifndef EMSOLVER_H
#define EMSOLVER_H

#include "Solver.h"

class CEMSolver : public CSolver
{
    public:

    CEMSolver(void);
    CEMSolver(const CSolverSettings& rSettings);
    virtual ~CEMSolver(void);

    virtual std::string GetDescription(void);

    protected:

    virtual bool Advance(float nTime, float ndt, float* pdW, float* pdZ, float* pXin, float* pXout);
};

#endif // EMSOLVER_H
