#include<iostream>

#include "ELF_LogManager.h"
#include "ELF_Properties.h"

DEFINE_EXCEPTION( LowestException ) ;
DEFINE_EXCEPTION( MiddleException ) ;
DEFINE_EXCEPTION( HighestException ) ;

ELF_FUNCT_DEF( void lowLevelAbstractionMethod1() throw( Exception ) ) {
	    THROW_EXCEPTION( LowestException, "A low level exception" ) ;
}
ELF_FUNCT_DEF_END

ELF_FUNCT_DEF( void highLevelAbstractionMethod4() throw( Exception ) ) {
    try {
        lowLevelAbstractionMethod1() ;
    }
    catch( Exception &e ) {
        THROW_NESTD_EXCPTN( HighestException, "A high level exception", e ) ;
    }
}
ELF_FUNCT_DEF_END

ELF_FUNCT_DEF( void highLevelAbstractionMethod3() throw( Exception ) ) {
    highLevelAbstractionMethod4() ;
}
ELF_FUNCT_DEF_END

ELF_FUNCT_DEF( void highLevelAbstractionMethod2() throw( Exception ) ) {
    highLevelAbstractionMethod3() ;
}
ELF_FUNCT_DEF_END

ELF_FUNCT_DEF( void highLevelAbstractionMethod1() throw( Exception ) ) {

    WARNG_LOG( "just a test warning" ) ;
    DEBUG_LOG( "just a test debug" ) ;
    ERROR_LOG( "just a test error" ) ;
    AUDIT_LOG( "just a test audit" ) ;
    CRIT_LOG( "just a test critical" ) ;
    highLevelAbstractionMethod2();
}
ELF_FUNCT_DEF_END

int main() {

    try {
        appConfig.initialize( "test.cfg" ) ;
        logManager.initialize( LogManager::FILEBASED ) ;
        logManager.addLogWriter( LogManager::UDPBASED ) ;
        logManager.addLogWriter( LogManager::TCPBASED ) ;
        highLevelAbstractionMethod1() ;
    }
    catch( Exception &e ) {
        cerr<<e<<endl ;
    }
    return 0 ;
}
