
//    Date : Sun May 13 13:55:57 EDT 2001
//    Author : Sony E Antony


//    File : ELF_Exception.C
//    File belongs to ELF : Exception Handling and Logging Framework.
//    sonyeantony@yahoo.com


#include<iostream>

#include"ELF_Exception.h"

using namespace ELF ;

namespace ELF {

    string ELF_FUNC_NAME = "" ;
    }

ostream& ELF::operator << ( ostream& os, const Exception &e ) {

    os<<"=============== EXCEPTION INFO BEGIN ======================"<<endl ;
    os<<e.toString()<<endl ;
    os<<"=============== EXCEPTION INFO END ========================"<<endl ;
    return os ;
}

string Exception::toString( const string &tab ) const {

    ostringstream os ;
    os<<line_ ;

    string s = tab + "WHAT : " + what() + "\n" +
        "REASON : " + reason_ + "\n" +
        "METHOD : " + method_ + "(" + file_ + ":" + os.str() + ")" ;
        if( !( ( getStackTrace() == "" ) || ( getStackTrace() == " " ) ) ) {
            s += "\n" + getStackTrace() ;
        }

        string s1 = "\n" ;
        string s2 = s1 + tab ;
        string::size_type index = 0 ;
        while( ( index = s.find( s1, index + s1.size() ) ) != string::npos ) {
            s.replace( index, s1.size(), s2 ) ;
        }
    if( nestedExceptn_ != NULL && nestedExceptn_->initialized_ ) {
        s += "\n" + tab + "NESTED EXCEPTION : \n" + nestedExceptn_->toString( tab + "    " ) ;
    }
    return s ;
}
