
//    Date : Sun May 13 13:55:57 EDT 2001
//    Author : Sony E Antony


//    File : ELF_FileWriterImpl.C
//    File belongs to ELF : Exception Handling and Logging Framework.
//    sonyeantony@yahoo.com



#include "ELF_FileWriterImpl.h"



using namespace std ;
using namespace ELF ;


FileWriterImpl::FileWriterImpl( const Properties &props ) throw ( Exception ) {

    critFilName_ = props.getProperty( "ELF_CRIT_LOG_FILE_NAME" ) ;
    errFilName_ = props.getProperty( "ELF_ERR_LOG_FILE_NAME" ) ;
    warnFilName_ = props.getProperty( "ELF_WARN_LOG_FILE_NAME" ) ;
    audtFilName_ = props.getProperty( "ELF_AUDT_LOG_FILE_NAME" ) ;
    debgFilName_ = props.getProperty( "ELF_DEBG_LOG_FILE_NAME" ) ;
    functCallFilName_ = props.getProperty( "ELF_FUNCT_CALL_TRACE_LOG_FILE_NAME" ) ;

    createEmptyFiles_() ;
}


void FileWriterImpl::createEmptyFiles_() throw ( Exception ) {

    { FileGuard file( openFileForAppend_( critFilName_ ) ) ; }
    { FileGuard file( openFileForAppend_( errFilName_ ) ) ; }
    { FileGuard file( openFileForAppend_( warnFilName_ ) ) ; }
    { FileGuard file( openFileForAppend_( audtFilName_ ) ) ; }
    { FileGuard file( openFileForAppend_( debgFilName_ ) ) ; }
    { FileGuard file( openFileForAppend_( functCallFilName_ ) ) ; }
}

