
//    Date : Sun Sep  1 20:09:28 EDT 2002
//    Author : Sony E Antony


//    File : ELF_MiscUtils.C
//    File belongs to ELF : Exception Handling and Logging Framework.
//    sonyeantony@yahoo.com


#include<time.h>
#include<errno.h>
#include<stdio.h>

#include"ELF_MiscUtils.h"

using namespace ELF ;


string ELF::currentDateTime() {

    time_t t ;
    time( &t ) ;
    struct tm tt ;
    localtime_r( &t, &tt ) ;
    char buf[100];
    strftime( buf,100,"%m/%d/%Y:%H-%M-%S", &tt ) ;
    return buf ;

    }

void ELF::renameFileWithDate( const string &fileName ) throw( Exception ) {

    string s = fileName + "." + currentDateTime() ;
    errno = 0 ;
    if( rename( fileName.c_str(), s.c_str() ) ) {
        ostringstream os ;
        os<<"Failed to backup LogFile : " <<fileName<<" to : "<< s <<endl ;
        os<<"Reason : "<<strerror( errno ) ;
        THROW_EXCEPTN_WWHERE( MiscException, "void FileManagerImpl::renameFileWithDate_( const string &fileName )", os.str() ) ;
    }
}


/* Courtesy Richard Stevens UNP v1 */

ssize_t ELF::writen( int fd, const void *vptr, size_t n ) {
    size_t nleft = n ;
    ssize_t nwritten ;
    const char *ptr = (char*)vptr ;

    while ( nleft > 0 ) {
        if ( ( nwritten = write( fd, ptr, nleft ) ) <= 0 ) {
            if( errno == EINTR ) {
                nwritten = 0 ;        /* and call write() again */
            }
            else {
                return( -1 ) ;            /* error */
            }
        }
        nleft -= nwritten ;
        ptr   += nwritten ;
    }
    return( n ) ;
}


