
//    Date : Sun Sep  1 20:06:42 EDT 2002
//    Author : Sony E Antony


//    File : ELF_MiscUtils.h
//    File belongs to ELF : Exception Handling and Logging Framework.
//    sonyeantony@yahoo.com


#ifndef __ELF_MISC_UTILS_H__
#define __ELF_MISC_UTILS_H__

#include<unistd.h>

#include<string>

#include"ELF_Exception.h"

namespace ELF {

using namespace std ;

DEFINE_EXCEPTION( MiscException ) ;

    string currentDateTime() ;

    void renameFileWithDate( const string &fileName ) throw( Exception ) ;
    ssize_t writen( int fd, const void *vptr, size_t n ) ;

class FileGuard {

    int fd_ ;
    bool tobeclosed_;
  public :
    FileGuard( int fd ) : fd_( fd ), tobeclosed_( true ) {}
    ~FileGuard() { if( tobeclosed_ ) { close( fd_ ) ; } }
    inline int fd() { return fd_ ; }
    inline void noClose() { tobeclosed_ = false ; }
  private :
    FileGuard( const FileGuard & ) {}
    void operator = ( const FileGuard & ) {}

} ;


}

#endif
