
//    Date : Sun Sep  1 20:06:42 EDT 2002
//    Author : Sony E Antony


//    File : ELF_Properties.h
//    File belongs to ELF : Exception Handling and Logging Framework.
//    sonyeantony@yahoo.com


#ifndef __ELF_PROPERTIES_H__
#define __ELF_PROPERTIES_H__

#include<fstream>

#include<map>
#include<string>

#include"ELF_Exception.h"

namespace ELF {

using namespace std ;

DEFINE_EXCEPTION( PropertiesException ) ;

typedef map<string, string> PropertyList ;

class  Properties {

public:

    Properties( ) : initialized_( false ) {}
    Properties( const string &cfgFileName ) throw ( Exception ) ;
    Properties( const PropertyList &proplist ) throw ( Exception ) ;
    void reInitialize( ) throw ( Exception ) ;
    void initialize( const string &cfgFileName ) throw ( Exception ) ;
    void initialize( const PropertyList proplist ) throw ( Exception ) ;

    string getApplicationName() { return applName_ ; }

    string getProperty( const string  &param ) const throw( Exception ) ;
    void setProperty( const string &property, const string &value )
        { properties_.insert( PropertyList::value_type( property, value ) ) ; }

    string getOptionalProperty( const string  &param ) const throw( Exception ) ;

    void setPropertyFileName( const string &cfgFileName )
        { cfgFileName_ = cfgFileName ; }
    string getPropertyFileName() { return cfgFileName_ ; }

    PropertyList& getPropertyList() { return properties_ ; }

  private:

    void readPropertiesFile_() throw ( Exception ) ;
    string cfgFileName_ ;
    string applName_ ;
    bool initialized_ ;
    PropertyList properties_ ;

} ;

    extern Properties appConfig ;

}

#endif
