
//    Date : Sun Sep  1 20:47:57 EDT 2002
//    Author : Sony E Antony


//    File : ELF_ResourceLockGuard.h
//    File belongs to ELF : Exception Handling and Logging Framework.
//    sonyeantony@yahoo.com


#ifndef __ELF_RESOURCE_LOCK_GUARD_H__
#define __ELF_RESOURCE_LOCK_GUARD_H__


#include"ELF_Exception.h"

using namespace std ;

namespace ELF {

    DEFINE_EXCEPTION( ResourceLockGuardException ) ;

    template< class T> class ResourceLockGuard {
    
    
    public:
    
        ResourceLockGuard( T &resource ) throw( Exception ) : resource_( resource ) { resource_.lock() ; }

        ~ResourceLockGuard( ) { resource_.unlock() ; }

      private:
    
        T &resource_ ;
        };
}

#endif
