
//    Date : Sun Sep  1 20:09:28 EDT 2002
//    Author : Sony E Antony


//    File : ELF_BlockingOperationSentry.h
//    File belongs to ELF : Exception Handling and Logging Framework.
//    sonyeantony@yahoo.com


#ifndef __ELF_BLOCKING_OPERATION_SENTRY_H__
#define __ELF_BLOCKING_OPERATION_SENTRY_H__


#include<iostream>

namespace ELF {

using namespace std ;

class BlockingOperationSentry {

  public :

      virtual void preBlock( void* data = NULL ) = 0 ;
      virtual void postBlock( void* data = NULL ) = 0 ;
      virtual ~BlockingOperationSentry() {}
};

class BlockingOperationSentryGuard {

    BlockingOperationSentry* co_ ;
  public :
    BlockingOperationSentryGuard( BlockingOperationSentry* co ): co_( co ) { if( co_ ) { co_->preBlock() ; } }
    ~BlockingOperationSentryGuard( ) { if( co_ ) { co_->postBlock() ; } }
};


}
#endif
