
//    Date : Sun Sep  1 20:09:28 EDT 2002
//    Author : Sony E Antony


//    File : ELF_LogServer.h
//    File belongs to ELF : Exception Handling and Logging Framework.
//    sonyeantony@yahoo.com


#ifndef __ELF_LOG_SERVER_H__
#define __ELF_LOG_SERVER_H__


#include "ELF_Exception.h"
#include "ELF_LogWriter.h"
#include "ELF_BlockingOperationSentry.h"

namespace ELF {

DEFINE_EXCEPTION( LogServerException ) ;

class LogServer {

    BlockingOperationSentry* callbackObj_ ;
    string logFile_ ;
  protected :
    LogWriter *logWriter_ ;
  public :

    LogServer( ) throw ( Exception ) ;
    ~LogServer( ) { delete logWriter_ ; }

    virtual void run( BlockingOperationSentry* co = NULL ) throw ( Exception ) = 0 ;
    virtual void shutdown() ;

    void writeLogServerMsgs( const string  &msg ) throw() ;

};

    LogServer* createLogServer( const string &type ) throw ( Exception ) ;
    extern LogServer* logServer ;

}
#endif
