
//    Date : Sun Sep  1 20:09:28 EDT 2002
//    Author : Sony E Antony


//    File : ELF_SignalManager.h
//    File belongs to ELF : Exception Handling and Logging Framework.
//    sonyeantony@yahoo.com

#ifndef __ELF_SIGNAL_MANAGER_H__
#define __ELF_SIGNAL_MANAGER_H__

#include<signal.h>

#include "ELF_Exception.h"
#include "ELF_BlockingOperationSentry.h"

namespace ELF {

using namespace std ;

DEFINE_EXCEPTION( SignalManagerException ) ;

class SignalManager : public BlockingOperationSentry {


    sigset_t sigmask_ ;
    sigset_t oldSigmask_ ;
  public :
      SignalManager() throw( Exception ) ;
      ~SignalManager() ;
      void preBlock( void* data ) ;
      void postBlock( void* data ) ;


};

}
#endif
