
//    Date : Sun Sep  1 20:09:28 EDT 2002
//    Author : Sony E Antony


//    File : ELF_UdpLogServerImpl.h
//    File belongs to ELF : Exception Handling and Logging Framework.
//    sonyeantony@yahoo.com


#ifndef __ELF_UDP_LOG_SERVER_IMPL_H__
#define __ELF_UDP_LOG_SERVER_IMPL_H__

#include<fstream>

#include "ELF_LogServer.h"
#include "ELF_LogWriter.h"
#include "ELF_Exception.h"
#include "ELF_UdpMessage.h"

namespace ELF {

DEFINE_EXCEPTION( UdpLogServerImplException ) ;

class UdpLogServerImpl : public LogServer {

    UdpMessage msg_;

    int port_ ;
    int socket_ ;
    string logsrvrLogFileName_ ;
    BlockingOperationSentry* callbackObj_ ;
  public :

    UdpLogServerImpl() throw ( Exception ) ;
    ~UdpLogServerImpl() ;
    void run( BlockingOperationSentry* co = NULL ) throw ( Exception ) ;

  private :

    void setupSocket_() throw ( Exception ) ;
    void readMessage_( string &clientIp ) throw ( Exception ) ;
    void processMessage_( const string &clientIp ) throw ( Exception ) ;

};

}
#endif
