#!/bin/bash

#    Date : Sun Sep  1 20:09:28 EDT 2002
#    Author : Sony E Antony


#    File : daemonLauncher.sh
#    File belongs to ELF : Exception Handling and Logging Framework.
#    sonyeantony@yahoo.com


#NOTE: to kill daemons launched with this script, daemonLauncher should be killed first, followed by the actual binary.


#change this to the maximum number of times to launch the server if it crashes.
NUM_RELAUNCH_ATTEMPTS=30

# change this to the proper directory
LOG_DIR=.

#The binary to launch
BIN_NAME='/home/sony/elf/logserver/elfLogserver -t -f /home/sony/elf/logserver/logserver.cfg'

#----------------------------

BIN_BASE_NAME=$(echo ${BIN_NAME}|awk '{print $1}')

LOG_FILE=${LOG_DIR}/$(basename ${BIN_BASE_NAME}).log


startDriverIfNotRunning() {

    if ps -elf|grep -v grep|grep ${BIN_BASE_NAME} >/dev/null ; then

        echo "${BIN_BASE_NAME} already running"
        exit 1
    else
        nohup $0 1 >/dev/null &
        exit 0
    fi
    }

driver() {

    typeset -i count=${NUM_RELAUNCH_ATTEMPTS}

    while [ $((count=count-1)) -ne -1 ] ; do

        echo ${STR}
        ${BIN_NAME}
        echo "${BIN_BASE_NAME} died. ( ${count} time )"
	STR='launching again'
	
    done >>${LOG_FILE} 2>&1

    echo "Tried To Launch ${BIN_BASE_NAME} ${NUM_RELAUNCH_ATTEMPTS} times.  Please Investigate" >>${LOG_FILE}
    exit 2
    }

main() {

    if [ $# = 0 ] ; then
        startDriverIfNotRunning
    else
        driver
    fi
    }

main $*


