/* From Meyers and Plum. "The New C: Low-Level I/O for Embedded Systems,"
 * C/C++ Users Journal, November 2003.
 *
 * This file declares the I/O Register Designators for the first parallel
 * port in the style of:
 * ISO/IEC TR 18037, C Extensions to Support Embedded Processors.
 *
 * Note: All names beginning with _ are private implementation details
 * only to be used by iohw.h, iohw.c, iolpt.h, and iolpt.c.
 *
 */

#ifndef _IOLPT_H
#define _IOLPT_H

/* LPT1_GROUP is the "I/O Group Designator" that indicates that we want
 * to access the I/O Register Designators for the first parallel port.  */
#define LPT1_GROUP 0

extern _IOreg lpt1_data;
extern _IOreg lpt1_status;
extern _IOreg lpt1_control;
extern _IOreg lpt1_ecp_control;

/* Extended Capabilities Port ecp_control register masks */
#define FIFO_EMPTY	0x01
#define FIFO_FULL	0x02

/* Standard Parallel Port control register masks */
#define STROBE		0x01
#define RESET		0x04
#define SELECT		0x08

/* Standard Parallel Port status register masks */
#define NOTBUSY		0x80

#endif /* _IOLPT_H */
