
//+---------------------------------------------------------------------------
//
//  Copyright (C) Microsoft Corporation, 2002.
//  Permission is granted to use this code without restriction as long as
//  this copyright notice appears in all source files.
//
//  File:       lock.h
//
//  Contents:   LOCK macro and supporting gclock class
//
//  Classes:    gclock
//
//  Functions:
//
//  Notes:
//
//  History:    11-08-2002   ericne     Created
//
//----------------------------------------------------------------------------

#if defined(_MSC_VER) & defined(_MANAGED)

#pragma once
#using <mscorlib.dll>
#include <gcroot.h>

class gclock
{
    gcroot<System::Object*> m_Object;
    gclock & operator=( gclock const & );
    gclock( gclock const & );
public:
    gclock( System::Object *o ) : m_Object( o )
    {
        System::Threading::Monitor::Enter( o );
    }
    ~gclock()
    {
        System::Threading::Monitor::Exit( m_Object );
    }
    operator bool() const
    {
        return false;
    }
};

#define LOCK(p) if( gclock __gclock = (p) ) {} else

#endif
