
#include "stdafx.h"
#using <mscorlib.dll>
#include <tchar.h>
#include "foreach.h"
#include "lock.h"
#include <list>
#include <string>

int _tmain()
{
    //
    // Some examples of using FOR_EACH
    //

    System::Collections::Stack *pIntStack = new System::Collections::Stack();
    pIntStack->Push( __box(1) );
    pIntStack->Push( __box(2) );
    pIntStack->Push( __box(3) );

    FOR_EACH( int, elem, pIntStack )
    {
        System::Console::WriteLine( elem );
    }

    System::Collections::ArrayList *pIntList = new System::Collections::ArrayList();
    pIntList->Add( __box(10) );
    pIntList->Add( __box(20) );
    pIntList->Add( __box(30) );

    FOR_EACH( int, elem, pIntList )
    {
        System::Console::WriteLine( elem );
    }

    System::Collections::ArrayList *pStringList = new System::Collections::ArrayList();
    pStringList->Add( S"Hello" );
    pStringList->Add( S"world!" );

    FOR_EACH( System::String*, elem, pStringList )
    {
        System::Console::WriteLine( elem );
    }

    System::String * str = S"Hello ";
    FOR_EACH( __wchar_t, ch, str )
    {
        System::Console::Write( ch );
    }
    System::Text::StringBuilder * strb = new System::Text::StringBuilder(S"world!");
    FOR_EACH( __wchar_t, ch, strb )
    {
        System::Console::Write( ch );
    }
    System::Console::WriteLine( S"" );
    System::Console::WriteLine( S"" );


    short rgInt __gc[] = { 1,2,3 };
    FOR_EACH( int, i, rgInt )
    {
        System::Console::WriteLine( i );
    }

    System::String* rgString __gc[] = { S"A", S"Cool", S"Macro" };
    FOR_EACH( System::String*, s, rgString )
    {
        System::Console::WriteLine( s );
    }

    size_t s = 2;

    System::Console::WriteLine( S"" );
    int rgDynInt __gc[] = new int __gc[ s ];
    FOR_EACH( int, i, rgDynInt )
    {
        System::Console::WriteLine( i );
    }

    System::Console::WriteLine( S"" );
    System::Array *pDynInt = rgDynInt;
    FOR_EACH( int, i, pDynInt )
    {
        System::Console::WriteLine( i );
    }

    System::Console::WriteLine( S"" );
    char rgIntNative[] = {'a','b','c'};
    FOR_EACH( int, i, rgIntNative )
    {
        System::Console::WriteLine( i );
    }

    System::Console::WriteLine( S"" );
    std::list< int > stl_list;
    stl_list.push_back( 1000 );
    stl_list.push_back( 2000 );
    stl_list.push_back( 3000 );
    FOR_EACH( int, i, stl_list )
    {
        System::Console::WriteLine( i );
    }

    System::Console::WriteLine( S"" );
    std::wstring stl_str( L"STL" );
    FOR_EACH( __wchar_t, ch, stl_str )
    {
        System::Console::WriteLine( ch );
    }

    System::Console::WriteLine( S"" );

    __wchar_t const *       szLiteral1 = L"__wchar_t*";
    unsigned short const *  szLiteral2 = L"unsigned short*";
    char const *            szLiteral3 = "char*";

    FOR_EACH( __wchar_t, ch, szLiteral1 ) { System::Console::Write( ch ); } System::Console::WriteLine( S"" );
    FOR_EACH( __wchar_t, ch, szLiteral2 ) { System::Console::Write( ch ); } System::Console::WriteLine( S"" );
    FOR_EACH( __wchar_t, ch, szLiteral3 ) { System::Console::Write( ch ); } System::Console::WriteLine( S"" );

    // The following two cases do not compile, by design

    // can't iterator a 2-D array
    //System::Console::WriteLine( S"" );
    //int rgrgInt __gc[,] = __gc new int __gc[10,2];
    ////System::Array *rgrgInt = __gc new int __gc[10,2];
    //FOR_EACH( int, i, rgrgInt )
    //{
    //    System::Console::WriteLine( i );
    //}

    // don't know how to iterate an Object
    //System::Object * pObj;
    //FOR_EACH( int, j, pObj )
    //{
    //    System::Console::WriteLine( j );
    //}

    //
    // an example of using LOCK
    //
    System::String *slock = new System::String(S"Hello");
    LOCK(slock)
    {
        // slock is locked here
    }
    // slock is not locked here

    return 0;
}
